"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getNativeValueTransferredForDoubleSidedTx = exports.getActionForDoubleSidedTx = void 0;
function getActionForDoubleSidedTx(interpretation) {
    var _a, _b;
    const nativeValueSent = ((_a = interpretation.assetsSent.find((asset) => asset.type === "native" /* AssetType.native */)) === null || _a === void 0 ? void 0 : _a.amount) || '0';
    const nativeValueReceived = ((_b = interpretation.assetsReceived.find((asset) => asset.type === "native" /* AssetType.native */)) === null || _b === void 0 ? void 0 : _b.amount) || '0';
    if (parseFloat(nativeValueSent) !== 0 && interpretation.assetsReceived.length) {
        return "bought" /* Action.bought */;
    }
    else if (parseFloat(nativeValueReceived) !== 0 && interpretation.assetsSent.length) {
        return "sold" /* Action.sold */;
    }
    else {
        console.log(`ERROR! Invalid NFT sale: received ${nativeValueReceived} ETH and ${interpretation.assetsReceived.length} tokens, sent ${nativeValueSent} ETH and ${interpretation.assetsSent.length} tokens`);
        return "unknown" /* Action.unknown */;
    }
}
exports.getActionForDoubleSidedTx = getActionForDoubleSidedTx;
function getNativeValueTransferredForDoubleSidedTx(interpretation) {
    var _a, _b;
    const nativeValueSent = ((_a = interpretation.assetsSent.find((asset) => asset.type === "native" /* AssetType.native */)) === null || _a === void 0 ? void 0 : _a.amount) || '0';
    const nativeValueReceived = ((_b = interpretation.assetsReceived.find((asset) => asset.type === "native" /* AssetType.native */)) === null || _b === void 0 ? void 0 : _b.amount) || '0';
    if (interpretation.actions[0] == 'bought' &&
        parseFloat(nativeValueReceived) === 0 &&
        parseFloat(nativeValueSent) !== 0) {
        return nativeValueSent;
    }
    else if (interpretation.actions[0] == 'sold' &&
        parseFloat(nativeValueSent) === 0 &&
        parseFloat(nativeValueReceived) !== 0) {
        return nativeValueReceived;
    }
    else {
        console.log(`Invalid NFT sale: action: ${interpretation.actions[0]}, received ${nativeValueReceived} ETH and ${interpretation.assetsReceived.length} tokens, sent ${nativeValueSent} ETH and ${interpretation.assetsSent.length} tokens`);
        return "unknown" /* Action.unknown */;
    }
}
exports.getNativeValueTransferredForDoubleSidedTx = getNativeValueTransferredForDoubleSidedTx;
//# sourceMappingURL=DoubleSidedTxInterpreter.js.map