import { InterpreterMap } from '../interfaces/contractInterpreter';
import { DecodedTx, Interaction } from '../interfaces/decoded';
import { Interpretation } from '../interfaces/interpreted';
import { Chain } from '../interfaces/utils';
import { DatabaseInterface } from '../utils/DatabaseInterface';
declare type ContractInterpretersMap = Record<string, InterpreterMap>;
declare class Interpreter {
    contractSpecificInterpreters: ContractInterpretersMap;
    userAddress: string | null;
    chain: Chain;
    db: DatabaseInterface;
    constructor(chain: Chain, userAddress?: string | null, db?: DatabaseInterface | null, additionalContractInterpreters?: Record<string, InterpreterMap>);
    updateUserAddress(userAddress: string): void;
    updateChain(chain: Chain): void;
    interpretSingleTx(decodedTx: DecodedTx, userAddressFromInput?: string | null, userNameFromInput?: string | null, entityMap?: Record<string, string | null>): Promise<Interpretation>;
    getNativeTokenValueSent(interactions: Interaction[], nativeValueSent: string | undefined, fromAddress: string, userAddress: string): string;
    getNativeTokenValueReceived(interactions: Interaction[], userAddress: string): string;
    getWethValue(interactions: Interaction[], userAddress: string, direction: 'received' | 'sent'): string;
    private findValue;
    private getTokens;
    private getAssetsReceived;
    private getAssetsSent;
    private useKeywordMap;
}
export default Interpreter;
