"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.decodeRawTxTrace = void 0;
const pruneTraceRecursive = (calls) => {
    if (!calls.length) {
        console.log('ERROR! Faulty structure of multicall subtraces');
        return [];
    }
    if (!calls[0].subtraces) {
        return calls;
    }
    const callsToRemove = calls[0].subtraces;
    let newRestOfCalls = [...calls];
    for (let i = 0; i < callsToRemove; i++) {
        newRestOfCalls = [newRestOfCalls[0], ...pruneTraceRecursive(newRestOfCalls.slice(1))];
        newRestOfCalls.splice(1, 1);
    }
    return newRestOfCalls;
};
function decodeRawTxTrace(abiDecoder, txTrace) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!txTrace.length) {
            return new Promise((resolve) => resolve([]));
        }
        const secondLevelCallsCount = txTrace[0].subtraces;
        const secondLevelCalls = [];
        let callsToPrune = txTrace.slice(1);
        for (let i = 0; i < secondLevelCallsCount; i++) {
            callsToPrune = pruneTraceRecursive(callsToPrune);
            secondLevelCalls.push(callsToPrune[0]);
            callsToPrune.shift();
        }
        if (callsToPrune.length) {
            console.log('ERROR! Faulty structure of multicall subtraces');
            return new Promise((resolve) => resolve([]));
        }
        return Promise.all(secondLevelCalls.map((call) => {
            var _a;
            return abiDecoder.decodeMethod(((_a = call.action) === null || _a === void 0 ? void 0 : _a.input) || '').then((decodedCall) => {
                var _a, _b;
                return (Object.assign(Object.assign({}, decodedCall), { from: (_a = call.action) === null || _a === void 0 ? void 0 : _a.from, to: (_b = call.action) === null || _b === void 0 ? void 0 : _b.to }));
            });
        }));
    });
}
exports.decodeRawTxTrace = decodeRawTxTrace;
//# sourceMappingURL=MulticallTxInterpreter.js.map