"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function isExecutionSuccessEvent(event) {
    return event.eventName === 'ExecutionSuccess';
}
function interpretGnosisExecution(decodedData, interpretation) {
    const { toAddress, interactions } = decodedData;
    const { userName } = interpretation;
    const action = "executed" /* Action.executed */;
    const tokenContractInteraction = interactions.find((interaction) => interaction.contractAddress === toAddress);
    const tokenEvents = (tokenContractInteraction === null || tokenContractInteraction === void 0 ? void 0 : tokenContractInteraction.events) || [];
    const counterpartyName = decodedData.toENS || (toAddress === null || toAddress === void 0 ? void 0 : toAddress.slice(0, 6));
    const isExecutionSuccess = tokenEvents.find((e) => isExecutionSuccessEvent(e));
    // if (!isExecutionSuccess) {
    //     logWarning(
    //         {
    //             tx_hash: decodedData.txHash,
    //             address: toAddress || undefined,
    //             function_name: 'interpretGnosisExecution',
    //         },
    //         'Gnosis tx didnt include ExecutionSuccess event',
    //     )
    // }
    const exampleDescription = `${userName} ${action} a transaction on a Gnosis Safe (${counterpartyName})`;
    interpretation.actions.push(action);
    interpretation.exampleDescription = exampleDescription;
    interpretation.extra = {};
}
exports.default = interpretGnosisExecution;
//# sourceMappingURL=gnosis.js.map