"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.transformTraceData = exports.transformDecodedData = exports.transformDecodedLogs = void 0;
const collect_js_1 = __importDefault(require("collect.js"));
const utils_1 = require("../interfaces/utils");
function transformDecodedLogs(decodedLogs, contractDataMap) {
    // tx.log_events.forEach((event) => {
    //     console.log('decoded', event)
    //     event.decoded.params.forEach((param) => {
    //         console.log('param', param)
    //     })
    // })
    const interactions = (0, collect_js_1.default)(decodedLogs)
        // .reject((event) => !event.sender_name)
        .reject((log) => !log)
        .mapToGroups((log) => {
        var _a, _b;
        // console.log('params', event.decoded.params)
        const events = Object.fromEntries((_b = (_a = log.events) === null || _a === void 0 ? void 0 : _a.map((param) => [
            param.name,
            // Array.isArray(param.value) ? param.value.map((arg) => arg.value) :
            param.value,
        ])) !== null && _b !== void 0 ? _b : []);
        const address = utils_1.AddressZ.parse(log.address);
        const contractData = contractDataMap[utils_1.AddressZ.parse(address)];
        return [
            address,
            {
                contractName: (contractData === null || contractData === void 0 ? void 0 : contractData.contractName) || null,
                contractSymbol: (contractData === null || contractData === void 0 ? void 0 : contractData.tokenSymbol) || null,
                contractAddress: utils_1.AddressZ.parse(address),
                contractType: contractData === null || contractData === void 0 ? void 0 : contractData.type,
                events: [
                    Object.assign({ eventName: log.name, logIndex: log.logIndex, params: events }, (!log.decoded && { decoded: log.decoded })),
                ],
            },
        ];
    })
        .map((interactions) => {
        return Object.assign(Object.assign({}, interactions[0]), { events: interactions.map((i) => i.events).flat() });
    });
    return interactions.values().toArray();
}
exports.transformDecodedLogs = transformDecodedLogs;
function transformDecodedData(rawDecodedCallData) {
    const params = {};
    rawDecodedCallData.params.forEach((param) => {
        params[param.name] = param.value;
    });
    return {
        name: rawDecodedCallData.name,
        params,
    };
}
exports.transformDecodedData = transformDecodedData;
function transformTraceData(rawDecodedTraceData) {
    const decodedTraceData = [];
    for (const call of rawDecodedTraceData) {
        const params = {};
        call.params.forEach((param) => {
            params[param.name] = param.value;
        });
        decodedTraceData.push({
            name: call.name,
            params,
        });
    }
    return decodedTraceData;
}
exports.transformTraceData = transformTraceData;
//# sourceMappingURL=transformDecodedLogs.js.map