import { z } from 'zod';
declare const ABI_FunctionOutputZ: z.ZodObject<{
    name: z.ZodOptional<z.ZodString>;
    type: z.ZodString;
    components: z.ZodOptional<z.ZodArray<z.ZodAny, "many">>;
}, "strip", z.ZodTypeAny, {
    name?: string | undefined;
    components?: any[] | undefined;
    type: string;
}, {
    name?: string | undefined;
    components?: any[] | undefined;
    type: string;
}>;
declare const ABI_FunctionInputZ: z.ZodObject<{
    name: z.ZodOptional<z.ZodString>;
    type: z.ZodString;
    components: z.ZodOptional<z.ZodArray<z.ZodAny, "many">>;
}, "strip", z.ZodTypeAny, {
    name?: string | undefined;
    components?: any[] | undefined;
    type: string;
}, {
    name?: string | undefined;
    components?: any[] | undefined;
    type: string;
}>;
declare const ABI_EventInputZ: z.ZodObject<z.extendShape<{
    name: z.ZodOptional<z.ZodString>;
    type: z.ZodString;
    components: z.ZodOptional<z.ZodArray<z.ZodAny, "many">>;
}, {
    indexed: z.ZodBoolean;
}>, "strip", z.ZodTypeAny, {
    name?: string | undefined;
    components?: any[] | undefined;
    type: string;
    indexed: boolean;
}, {
    name?: string | undefined;
    components?: any[] | undefined;
    type: string;
    indexed: boolean;
}>;
export declare type ABI_FunctionOutput = z.infer<typeof ABI_FunctionOutputZ>;
export declare type ABI_FunctionInput = z.infer<typeof ABI_FunctionInputZ>;
export declare type ABI_EventInput = z.infer<typeof ABI_EventInputZ>;
export declare const ABI_Type: z.ZodEnum<["function", "event", "constructor", "fallback", "receive", "error"]>;
export declare const StateMutability: z.ZodEnum<["pure", "view", "nonpayable", "payable"]>;
export declare const writeStates: string[];
export declare const readStates: string[];
export declare const ABI_ConstructorZ: z.ZodObject<{
    type: z.ZodLiteral<"constructor">;
    inputs: z.ZodArray<z.ZodObject<{
        name: z.ZodOptional<z.ZodString>;
        type: z.ZodString;
        components: z.ZodOptional<z.ZodArray<z.ZodAny, "many">>;
    }, "strip", z.ZodTypeAny, {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }, {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }>, "many">;
    stateMutability: z.ZodOptional<z.ZodEnum<["pure", "view", "nonpayable", "payable"]>>;
}, "strip", z.ZodTypeAny, {
    stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
    type: "constructor";
    inputs: {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }[];
}, {
    stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
    type: "constructor";
    inputs: {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }[];
}>;
export declare const ABI_FunctionZ: z.ZodObject<{
    type: z.ZodLiteral<"function">;
    name: z.ZodString;
    inputs: z.ZodArray<z.ZodObject<{
        name: z.ZodOptional<z.ZodString>;
        type: z.ZodString;
        components: z.ZodOptional<z.ZodArray<z.ZodAny, "many">>;
    }, "strip", z.ZodTypeAny, {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }, {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }>, "many">;
    outputs: z.ZodArray<z.ZodObject<{
        name: z.ZodOptional<z.ZodString>;
        type: z.ZodString;
        components: z.ZodOptional<z.ZodArray<z.ZodAny, "many">>;
    }, "strip", z.ZodTypeAny, {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }, {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }>, "many">;
    stateMutability: z.ZodOptional<z.ZodEnum<["pure", "view", "nonpayable", "payable"]>>;
    constant: z.ZodOptional<z.ZodBoolean>;
    payable: z.ZodOptional<z.ZodBoolean>;
}, "strip", z.ZodTypeAny, {
    payable?: boolean | undefined;
    stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
    constant?: boolean | undefined;
    type: "function";
    name: string;
    inputs: {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }[];
    outputs: {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }[];
}, {
    payable?: boolean | undefined;
    stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
    constant?: boolean | undefined;
    type: "function";
    name: string;
    inputs: {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }[];
    outputs: {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }[];
}>;
export declare const ABI_EventZ: z.ZodObject<{
    type: z.ZodLiteral<"event">;
    name: z.ZodString;
    inputs: z.ZodArray<z.ZodObject<z.extendShape<{
        name: z.ZodOptional<z.ZodString>;
        type: z.ZodString;
        components: z.ZodOptional<z.ZodArray<z.ZodAny, "many">>;
    }, {
        indexed: z.ZodBoolean;
    }>, "strip", z.ZodTypeAny, {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
        indexed: boolean;
    }, {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
        indexed: boolean;
    }>, "many">;
    anonymous: z.ZodBoolean;
}, "strip", z.ZodTypeAny, {
    type: "event";
    name: string;
    inputs: {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
        indexed: boolean;
    }[];
    anonymous: boolean;
}, {
    type: "event";
    name: string;
    inputs: {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
        indexed: boolean;
    }[];
    anonymous: boolean;
}>;
export declare const ABI_ReceiveZ: z.ZodObject<{
    type: z.ZodLiteral<"receive">;
    stateMutability: z.ZodOptional<z.ZodEnum<["pure", "view", "nonpayable", "payable"]>>;
    constant: z.ZodOptional<z.ZodBoolean>;
    payable: z.ZodOptional<z.ZodBoolean>;
}, "strip", z.ZodTypeAny, {
    payable?: boolean | undefined;
    stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
    constant?: boolean | undefined;
    type: "receive";
}, {
    payable?: boolean | undefined;
    stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
    constant?: boolean | undefined;
    type: "receive";
}>;
export declare const ABI_FallbackZ: z.ZodObject<{
    type: z.ZodLiteral<"fallback">;
    stateMutability: z.ZodOptional<z.ZodEnum<["pure", "view", "nonpayable", "payable"]>>;
    constant: z.ZodOptional<z.ZodBoolean>;
    payable: z.ZodOptional<z.ZodBoolean>;
}, "strip", z.ZodTypeAny, {
    payable?: boolean | undefined;
    stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
    constant?: boolean | undefined;
    type: "fallback";
}, {
    payable?: boolean | undefined;
    stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
    constant?: boolean | undefined;
    type: "fallback";
}>;
export declare const ABI_ErrorZ: z.ZodObject<{
    type: z.ZodLiteral<"error">;
    name: z.ZodString;
    inputs: z.ZodArray<z.ZodObject<{
        name: z.ZodOptional<z.ZodString>;
        type: z.ZodString;
        components: z.ZodOptional<z.ZodArray<z.ZodAny, "many">>;
    }, "strip", z.ZodTypeAny, {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }, {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }>, "many">;
}, "strip", z.ZodTypeAny, {
    type: "error";
    name: string;
    inputs: {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }[];
}, {
    type: "error";
    name: string;
    inputs: {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }[];
}>;
export declare const ABI_ItemUnfilteredZ: z.ZodDiscriminatedUnion<"type", z.Primitive, z.ZodObject<{
    type: z.ZodLiteral<"constructor">;
    inputs: z.ZodArray<z.ZodObject<{
        name: z.ZodOptional<z.ZodString>;
        type: z.ZodString;
        components: z.ZodOptional<z.ZodArray<z.ZodAny, "many">>;
    }, "strip", z.ZodTypeAny, {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }, {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }>, "many">;
    stateMutability: z.ZodOptional<z.ZodEnum<["pure", "view", "nonpayable", "payable"]>>;
}, "strip", z.ZodTypeAny, {
    stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
    type: "constructor";
    inputs: {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }[];
}, {
    stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
    type: "constructor";
    inputs: {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }[];
}> | z.ZodObject<{
    type: z.ZodLiteral<"function">;
    name: z.ZodString;
    inputs: z.ZodArray<z.ZodObject<{
        name: z.ZodOptional<z.ZodString>;
        type: z.ZodString;
        components: z.ZodOptional<z.ZodArray<z.ZodAny, "many">>;
    }, "strip", z.ZodTypeAny, {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }, {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }>, "many">;
    outputs: z.ZodArray<z.ZodObject<{
        name: z.ZodOptional<z.ZodString>;
        type: z.ZodString;
        components: z.ZodOptional<z.ZodArray<z.ZodAny, "many">>;
    }, "strip", z.ZodTypeAny, {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }, {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }>, "many">;
    stateMutability: z.ZodOptional<z.ZodEnum<["pure", "view", "nonpayable", "payable"]>>;
    constant: z.ZodOptional<z.ZodBoolean>;
    payable: z.ZodOptional<z.ZodBoolean>;
}, "strip", z.ZodTypeAny, {
    payable?: boolean | undefined;
    stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
    constant?: boolean | undefined;
    type: "function";
    name: string;
    inputs: {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }[];
    outputs: {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }[];
}, {
    payable?: boolean | undefined;
    stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
    constant?: boolean | undefined;
    type: "function";
    name: string;
    inputs: {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }[];
    outputs: {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }[];
}> | z.ZodObject<{
    type: z.ZodLiteral<"event">;
    name: z.ZodString;
    inputs: z.ZodArray<z.ZodObject<z.extendShape<{
        name: z.ZodOptional<z.ZodString>;
        type: z.ZodString;
        components: z.ZodOptional<z.ZodArray<z.ZodAny, "many">>;
    }, {
        indexed: z.ZodBoolean;
    }>, "strip", z.ZodTypeAny, {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
        indexed: boolean;
    }, {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
        indexed: boolean;
    }>, "many">;
    anonymous: z.ZodBoolean;
}, "strip", z.ZodTypeAny, {
    type: "event";
    name: string;
    inputs: {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
        indexed: boolean;
    }[];
    anonymous: boolean;
}, {
    type: "event";
    name: string;
    inputs: {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
        indexed: boolean;
    }[];
    anonymous: boolean;
}> | z.ZodObject<{
    type: z.ZodLiteral<"receive">;
    stateMutability: z.ZodOptional<z.ZodEnum<["pure", "view", "nonpayable", "payable"]>>;
    constant: z.ZodOptional<z.ZodBoolean>;
    payable: z.ZodOptional<z.ZodBoolean>;
}, "strip", z.ZodTypeAny, {
    payable?: boolean | undefined;
    stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
    constant?: boolean | undefined;
    type: "receive";
}, {
    payable?: boolean | undefined;
    stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
    constant?: boolean | undefined;
    type: "receive";
}> | z.ZodObject<{
    type: z.ZodLiteral<"fallback">;
    stateMutability: z.ZodOptional<z.ZodEnum<["pure", "view", "nonpayable", "payable"]>>;
    constant: z.ZodOptional<z.ZodBoolean>;
    payable: z.ZodOptional<z.ZodBoolean>;
}, "strip", z.ZodTypeAny, {
    payable?: boolean | undefined;
    stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
    constant?: boolean | undefined;
    type: "fallback";
}, {
    payable?: boolean | undefined;
    stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
    constant?: boolean | undefined;
    type: "fallback";
}> | z.ZodObject<{
    type: z.ZodLiteral<"error">;
    name: z.ZodString;
    inputs: z.ZodArray<z.ZodObject<{
        name: z.ZodOptional<z.ZodString>;
        type: z.ZodString;
        components: z.ZodOptional<z.ZodArray<z.ZodAny, "many">>;
    }, "strip", z.ZodTypeAny, {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }, {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }>, "many">;
}, "strip", z.ZodTypeAny, {
    type: "error";
    name: string;
    inputs: {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }[];
}, {
    type: "error";
    name: string;
    inputs: {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }[];
}>>;
export declare const ABI_ItemZ: z.ZodDiscriminatedUnion<"type", z.Primitive, z.ZodObject<{
    type: z.ZodLiteral<"function">;
    name: z.ZodString;
    inputs: z.ZodArray<z.ZodObject<{
        name: z.ZodOptional<z.ZodString>;
        type: z.ZodString;
        components: z.ZodOptional<z.ZodArray<z.ZodAny, "many">>;
    }, "strip", z.ZodTypeAny, {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }, {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }>, "many">;
    outputs: z.ZodArray<z.ZodObject<{
        name: z.ZodOptional<z.ZodString>;
        type: z.ZodString;
        components: z.ZodOptional<z.ZodArray<z.ZodAny, "many">>;
    }, "strip", z.ZodTypeAny, {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }, {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }>, "many">;
    stateMutability: z.ZodOptional<z.ZodEnum<["pure", "view", "nonpayable", "payable"]>>;
    constant: z.ZodOptional<z.ZodBoolean>;
    payable: z.ZodOptional<z.ZodBoolean>;
}, "strip", z.ZodTypeAny, {
    payable?: boolean | undefined;
    stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
    constant?: boolean | undefined;
    type: "function";
    name: string;
    inputs: {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }[];
    outputs: {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }[];
}, {
    payable?: boolean | undefined;
    stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
    constant?: boolean | undefined;
    type: "function";
    name: string;
    inputs: {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }[];
    outputs: {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
    }[];
}> | z.ZodObject<{
    type: z.ZodLiteral<"event">;
    name: z.ZodString;
    inputs: z.ZodArray<z.ZodObject<z.extendShape<{
        name: z.ZodOptional<z.ZodString>;
        type: z.ZodString;
        components: z.ZodOptional<z.ZodArray<z.ZodAny, "many">>;
    }, {
        indexed: z.ZodBoolean;
    }>, "strip", z.ZodTypeAny, {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
        indexed: boolean;
    }, {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
        indexed: boolean;
    }>, "many">;
    anonymous: z.ZodBoolean;
}, "strip", z.ZodTypeAny, {
    type: "event";
    name: string;
    inputs: {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
        indexed: boolean;
    }[];
    anonymous: boolean;
}, {
    type: "event";
    name: string;
    inputs: {
        name?: string | undefined;
        components?: any[] | undefined;
        type: string;
        indexed: boolean;
    }[];
    anonymous: boolean;
}>>;
export declare const ABI_RowConstructorZ: z.ZodObject<{
    name: z.ZodString;
    type: z.ZodLiteral<"constructor">;
    hashableSignature: z.ZodString;
    hashedSignature: z.ZodString;
    fullSignature: z.ZodString;
    abiJSON: z.ZodObject<{
        type: z.ZodLiteral<"constructor">;
        inputs: z.ZodArray<z.ZodObject<{
            name: z.ZodOptional<z.ZodString>;
            type: z.ZodString;
            components: z.ZodOptional<z.ZodArray<z.ZodAny, "many">>;
        }, "strip", z.ZodTypeAny, {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }, {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }>, "many">;
        stateMutability: z.ZodOptional<z.ZodEnum<["pure", "view", "nonpayable", "payable"]>>;
    }, "strip", z.ZodTypeAny, {
        stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
        type: "constructor";
        inputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }[];
    }, {
        stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
        type: "constructor";
        inputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }[];
    }>;
    default: z.ZodOptional<z.ZodBoolean>;
}, "strip", z.ZodTypeAny, {
    default?: boolean | undefined;
    type: "constructor";
    name: string;
    hashableSignature: string;
    hashedSignature: string;
    fullSignature: string;
    abiJSON: {
        stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
        type: "constructor";
        inputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }[];
    };
}, {
    default?: boolean | undefined;
    type: "constructor";
    name: string;
    hashableSignature: string;
    hashedSignature: string;
    fullSignature: string;
    abiJSON: {
        stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
        type: "constructor";
        inputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }[];
    };
}>;
export declare const ABI_RowFunctionZ: z.ZodObject<{
    name: z.ZodString;
    type: z.ZodLiteral<"function">;
    hashableSignature: z.ZodString;
    hashedSignature: z.ZodString;
    fullSignature: z.ZodString;
    abiJSON: z.ZodObject<{
        type: z.ZodLiteral<"function">;
        name: z.ZodString;
        inputs: z.ZodArray<z.ZodObject<{
            name: z.ZodOptional<z.ZodString>;
            type: z.ZodString;
            components: z.ZodOptional<z.ZodArray<z.ZodAny, "many">>;
        }, "strip", z.ZodTypeAny, {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }, {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }>, "many">;
        outputs: z.ZodArray<z.ZodObject<{
            name: z.ZodOptional<z.ZodString>;
            type: z.ZodString;
            components: z.ZodOptional<z.ZodArray<z.ZodAny, "many">>;
        }, "strip", z.ZodTypeAny, {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }, {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }>, "many">;
        stateMutability: z.ZodOptional<z.ZodEnum<["pure", "view", "nonpayable", "payable"]>>;
        constant: z.ZodOptional<z.ZodBoolean>;
        payable: z.ZodOptional<z.ZodBoolean>;
    }, "strip", z.ZodTypeAny, {
        payable?: boolean | undefined;
        stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
        constant?: boolean | undefined;
        type: "function";
        name: string;
        inputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }[];
        outputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }[];
    }, {
        payable?: boolean | undefined;
        stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
        constant?: boolean | undefined;
        type: "function";
        name: string;
        inputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }[];
        outputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }[];
    }>;
    default: z.ZodOptional<z.ZodBoolean>;
}, "strip", z.ZodTypeAny, {
    default?: boolean | undefined;
    type: "function";
    name: string;
    hashableSignature: string;
    hashedSignature: string;
    fullSignature: string;
    abiJSON: {
        payable?: boolean | undefined;
        stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
        constant?: boolean | undefined;
        type: "function";
        name: string;
        inputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }[];
        outputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }[];
    };
}, {
    default?: boolean | undefined;
    type: "function";
    name: string;
    hashableSignature: string;
    hashedSignature: string;
    fullSignature: string;
    abiJSON: {
        payable?: boolean | undefined;
        stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
        constant?: boolean | undefined;
        type: "function";
        name: string;
        inputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }[];
        outputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }[];
    };
}>;
export declare const ABI_RowEventZ: z.ZodObject<{
    name: z.ZodString;
    type: z.ZodLiteral<"event">;
    hashableSignature: z.ZodString;
    hashedSignature: z.ZodString;
    fullSignature: z.ZodString;
    abiJSON: z.ZodObject<{
        type: z.ZodLiteral<"event">;
        name: z.ZodString;
        inputs: z.ZodArray<z.ZodObject<z.extendShape<{
            name: z.ZodOptional<z.ZodString>;
            type: z.ZodString;
            components: z.ZodOptional<z.ZodArray<z.ZodAny, "many">>;
        }, {
            indexed: z.ZodBoolean;
        }>, "strip", z.ZodTypeAny, {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
            indexed: boolean;
        }, {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
            indexed: boolean;
        }>, "many">;
        anonymous: z.ZodBoolean;
    }, "strip", z.ZodTypeAny, {
        type: "event";
        name: string;
        inputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
            indexed: boolean;
        }[];
        anonymous: boolean;
    }, {
        type: "event";
        name: string;
        inputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
            indexed: boolean;
        }[];
        anonymous: boolean;
    }>;
    default: z.ZodOptional<z.ZodBoolean>;
}, "strip", z.ZodTypeAny, {
    default?: boolean | undefined;
    type: "event";
    name: string;
    hashableSignature: string;
    hashedSignature: string;
    fullSignature: string;
    abiJSON: {
        type: "event";
        name: string;
        inputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
            indexed: boolean;
        }[];
        anonymous: boolean;
    };
}, {
    default?: boolean | undefined;
    type: "event";
    name: string;
    hashableSignature: string;
    hashedSignature: string;
    fullSignature: string;
    abiJSON: {
        type: "event";
        name: string;
        inputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
            indexed: boolean;
        }[];
        anonymous: boolean;
    };
}>;
export declare const ABI_RowReceiveZ: z.ZodObject<{
    name: z.ZodString;
    type: z.ZodLiteral<"receive">;
    hashableSignature: z.ZodString;
    hashedSignature: z.ZodString;
    fullSignature: z.ZodString;
    abiJSON: z.ZodObject<{
        type: z.ZodLiteral<"receive">;
        stateMutability: z.ZodOptional<z.ZodEnum<["pure", "view", "nonpayable", "payable"]>>;
        constant: z.ZodOptional<z.ZodBoolean>;
        payable: z.ZodOptional<z.ZodBoolean>;
    }, "strip", z.ZodTypeAny, {
        payable?: boolean | undefined;
        stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
        constant?: boolean | undefined;
        type: "receive";
    }, {
        payable?: boolean | undefined;
        stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
        constant?: boolean | undefined;
        type: "receive";
    }>;
    default: z.ZodOptional<z.ZodBoolean>;
}, "strip", z.ZodTypeAny, {
    default?: boolean | undefined;
    type: "receive";
    name: string;
    hashableSignature: string;
    hashedSignature: string;
    fullSignature: string;
    abiJSON: {
        payable?: boolean | undefined;
        stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
        constant?: boolean | undefined;
        type: "receive";
    };
}, {
    default?: boolean | undefined;
    type: "receive";
    name: string;
    hashableSignature: string;
    hashedSignature: string;
    fullSignature: string;
    abiJSON: {
        payable?: boolean | undefined;
        stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
        constant?: boolean | undefined;
        type: "receive";
    };
}>;
export declare const ABI_RowFallbackZ: z.ZodObject<{
    name: z.ZodString;
    type: z.ZodLiteral<"fallback">;
    hashableSignature: z.ZodString;
    hashedSignature: z.ZodString;
    fullSignature: z.ZodString;
    abiJSON: z.ZodObject<{
        type: z.ZodLiteral<"fallback">;
        stateMutability: z.ZodOptional<z.ZodEnum<["pure", "view", "nonpayable", "payable"]>>;
        constant: z.ZodOptional<z.ZodBoolean>;
        payable: z.ZodOptional<z.ZodBoolean>;
    }, "strip", z.ZodTypeAny, {
        payable?: boolean | undefined;
        stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
        constant?: boolean | undefined;
        type: "fallback";
    }, {
        payable?: boolean | undefined;
        stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
        constant?: boolean | undefined;
        type: "fallback";
    }>;
    default: z.ZodOptional<z.ZodBoolean>;
}, "strip", z.ZodTypeAny, {
    default?: boolean | undefined;
    type: "fallback";
    name: string;
    hashableSignature: string;
    hashedSignature: string;
    fullSignature: string;
    abiJSON: {
        payable?: boolean | undefined;
        stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
        constant?: boolean | undefined;
        type: "fallback";
    };
}, {
    default?: boolean | undefined;
    type: "fallback";
    name: string;
    hashableSignature: string;
    hashedSignature: string;
    fullSignature: string;
    abiJSON: {
        payable?: boolean | undefined;
        stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
        constant?: boolean | undefined;
        type: "fallback";
    };
}>;
export declare const ABI_RowErrorZ: z.ZodObject<{
    name: z.ZodString;
    type: z.ZodLiteral<"error">;
    hashableSignature: z.ZodString;
    hashedSignature: z.ZodString;
    fullSignature: z.ZodString;
    abiJSON: z.ZodObject<{
        type: z.ZodLiteral<"error">;
        name: z.ZodString;
        inputs: z.ZodArray<z.ZodObject<{
            name: z.ZodOptional<z.ZodString>;
            type: z.ZodString;
            components: z.ZodOptional<z.ZodArray<z.ZodAny, "many">>;
        }, "strip", z.ZodTypeAny, {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }, {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }>, "many">;
    }, "strip", z.ZodTypeAny, {
        type: "error";
        name: string;
        inputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }[];
    }, {
        type: "error";
        name: string;
        inputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }[];
    }>;
    default: z.ZodOptional<z.ZodBoolean>;
}, "strip", z.ZodTypeAny, {
    default?: boolean | undefined;
    type: "error";
    name: string;
    hashableSignature: string;
    hashedSignature: string;
    fullSignature: string;
    abiJSON: {
        type: "error";
        name: string;
        inputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }[];
    };
}, {
    default?: boolean | undefined;
    type: "error";
    name: string;
    hashableSignature: string;
    hashedSignature: string;
    fullSignature: string;
    abiJSON: {
        type: "error";
        name: string;
        inputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }[];
    };
}>;
export declare const ABI_RowZ: z.ZodDiscriminatedUnion<"type", z.Primitive, z.ZodObject<{
    name: z.ZodString;
    type: z.ZodLiteral<"constructor">;
    hashableSignature: z.ZodString;
    hashedSignature: z.ZodString;
    fullSignature: z.ZodString;
    abiJSON: z.ZodObject<{
        type: z.ZodLiteral<"constructor">;
        inputs: z.ZodArray<z.ZodObject<{
            name: z.ZodOptional<z.ZodString>;
            type: z.ZodString;
            components: z.ZodOptional<z.ZodArray<z.ZodAny, "many">>;
        }, "strip", z.ZodTypeAny, {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }, {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }>, "many">;
        stateMutability: z.ZodOptional<z.ZodEnum<["pure", "view", "nonpayable", "payable"]>>;
    }, "strip", z.ZodTypeAny, {
        stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
        type: "constructor";
        inputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }[];
    }, {
        stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
        type: "constructor";
        inputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }[];
    }>;
    default: z.ZodOptional<z.ZodBoolean>;
}, "strip", z.ZodTypeAny, {
    default?: boolean | undefined;
    type: "constructor";
    name: string;
    hashableSignature: string;
    hashedSignature: string;
    fullSignature: string;
    abiJSON: {
        stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
        type: "constructor";
        inputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }[];
    };
}, {
    default?: boolean | undefined;
    type: "constructor";
    name: string;
    hashableSignature: string;
    hashedSignature: string;
    fullSignature: string;
    abiJSON: {
        stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
        type: "constructor";
        inputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }[];
    };
}> | z.ZodObject<{
    name: z.ZodString;
    type: z.ZodLiteral<"function">;
    hashableSignature: z.ZodString;
    hashedSignature: z.ZodString;
    fullSignature: z.ZodString;
    abiJSON: z.ZodObject<{
        type: z.ZodLiteral<"function">;
        name: z.ZodString;
        inputs: z.ZodArray<z.ZodObject<{
            name: z.ZodOptional<z.ZodString>;
            type: z.ZodString;
            components: z.ZodOptional<z.ZodArray<z.ZodAny, "many">>;
        }, "strip", z.ZodTypeAny, {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }, {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }>, "many">;
        outputs: z.ZodArray<z.ZodObject<{
            name: z.ZodOptional<z.ZodString>;
            type: z.ZodString;
            components: z.ZodOptional<z.ZodArray<z.ZodAny, "many">>;
        }, "strip", z.ZodTypeAny, {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }, {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }>, "many">;
        stateMutability: z.ZodOptional<z.ZodEnum<["pure", "view", "nonpayable", "payable"]>>;
        constant: z.ZodOptional<z.ZodBoolean>;
        payable: z.ZodOptional<z.ZodBoolean>;
    }, "strip", z.ZodTypeAny, {
        payable?: boolean | undefined;
        stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
        constant?: boolean | undefined;
        type: "function";
        name: string;
        inputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }[];
        outputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }[];
    }, {
        payable?: boolean | undefined;
        stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
        constant?: boolean | undefined;
        type: "function";
        name: string;
        inputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }[];
        outputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }[];
    }>;
    default: z.ZodOptional<z.ZodBoolean>;
}, "strip", z.ZodTypeAny, {
    default?: boolean | undefined;
    type: "function";
    name: string;
    hashableSignature: string;
    hashedSignature: string;
    fullSignature: string;
    abiJSON: {
        payable?: boolean | undefined;
        stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
        constant?: boolean | undefined;
        type: "function";
        name: string;
        inputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }[];
        outputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }[];
    };
}, {
    default?: boolean | undefined;
    type: "function";
    name: string;
    hashableSignature: string;
    hashedSignature: string;
    fullSignature: string;
    abiJSON: {
        payable?: boolean | undefined;
        stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
        constant?: boolean | undefined;
        type: "function";
        name: string;
        inputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }[];
        outputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }[];
    };
}> | z.ZodObject<{
    name: z.ZodString;
    type: z.ZodLiteral<"event">;
    hashableSignature: z.ZodString;
    hashedSignature: z.ZodString;
    fullSignature: z.ZodString;
    abiJSON: z.ZodObject<{
        type: z.ZodLiteral<"event">;
        name: z.ZodString;
        inputs: z.ZodArray<z.ZodObject<z.extendShape<{
            name: z.ZodOptional<z.ZodString>;
            type: z.ZodString;
            components: z.ZodOptional<z.ZodArray<z.ZodAny, "many">>;
        }, {
            indexed: z.ZodBoolean;
        }>, "strip", z.ZodTypeAny, {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
            indexed: boolean;
        }, {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
            indexed: boolean;
        }>, "many">;
        anonymous: z.ZodBoolean;
    }, "strip", z.ZodTypeAny, {
        type: "event";
        name: string;
        inputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
            indexed: boolean;
        }[];
        anonymous: boolean;
    }, {
        type: "event";
        name: string;
        inputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
            indexed: boolean;
        }[];
        anonymous: boolean;
    }>;
    default: z.ZodOptional<z.ZodBoolean>;
}, "strip", z.ZodTypeAny, {
    default?: boolean | undefined;
    type: "event";
    name: string;
    hashableSignature: string;
    hashedSignature: string;
    fullSignature: string;
    abiJSON: {
        type: "event";
        name: string;
        inputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
            indexed: boolean;
        }[];
        anonymous: boolean;
    };
}, {
    default?: boolean | undefined;
    type: "event";
    name: string;
    hashableSignature: string;
    hashedSignature: string;
    fullSignature: string;
    abiJSON: {
        type: "event";
        name: string;
        inputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
            indexed: boolean;
        }[];
        anonymous: boolean;
    };
}> | z.ZodObject<{
    name: z.ZodString;
    type: z.ZodLiteral<"receive">;
    hashableSignature: z.ZodString;
    hashedSignature: z.ZodString;
    fullSignature: z.ZodString;
    abiJSON: z.ZodObject<{
        type: z.ZodLiteral<"receive">;
        stateMutability: z.ZodOptional<z.ZodEnum<["pure", "view", "nonpayable", "payable"]>>;
        constant: z.ZodOptional<z.ZodBoolean>;
        payable: z.ZodOptional<z.ZodBoolean>;
    }, "strip", z.ZodTypeAny, {
        payable?: boolean | undefined;
        stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
        constant?: boolean | undefined;
        type: "receive";
    }, {
        payable?: boolean | undefined;
        stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
        constant?: boolean | undefined;
        type: "receive";
    }>;
    default: z.ZodOptional<z.ZodBoolean>;
}, "strip", z.ZodTypeAny, {
    default?: boolean | undefined;
    type: "receive";
    name: string;
    hashableSignature: string;
    hashedSignature: string;
    fullSignature: string;
    abiJSON: {
        payable?: boolean | undefined;
        stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
        constant?: boolean | undefined;
        type: "receive";
    };
}, {
    default?: boolean | undefined;
    type: "receive";
    name: string;
    hashableSignature: string;
    hashedSignature: string;
    fullSignature: string;
    abiJSON: {
        payable?: boolean | undefined;
        stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
        constant?: boolean | undefined;
        type: "receive";
    };
}> | z.ZodObject<{
    name: z.ZodString;
    type: z.ZodLiteral<"fallback">;
    hashableSignature: z.ZodString;
    hashedSignature: z.ZodString;
    fullSignature: z.ZodString;
    abiJSON: z.ZodObject<{
        type: z.ZodLiteral<"fallback">;
        stateMutability: z.ZodOptional<z.ZodEnum<["pure", "view", "nonpayable", "payable"]>>;
        constant: z.ZodOptional<z.ZodBoolean>;
        payable: z.ZodOptional<z.ZodBoolean>;
    }, "strip", z.ZodTypeAny, {
        payable?: boolean | undefined;
        stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
        constant?: boolean | undefined;
        type: "fallback";
    }, {
        payable?: boolean | undefined;
        stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
        constant?: boolean | undefined;
        type: "fallback";
    }>;
    default: z.ZodOptional<z.ZodBoolean>;
}, "strip", z.ZodTypeAny, {
    default?: boolean | undefined;
    type: "fallback";
    name: string;
    hashableSignature: string;
    hashedSignature: string;
    fullSignature: string;
    abiJSON: {
        payable?: boolean | undefined;
        stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
        constant?: boolean | undefined;
        type: "fallback";
    };
}, {
    default?: boolean | undefined;
    type: "fallback";
    name: string;
    hashableSignature: string;
    hashedSignature: string;
    fullSignature: string;
    abiJSON: {
        payable?: boolean | undefined;
        stateMutability?: "view" | "pure" | "nonpayable" | "payable" | undefined;
        constant?: boolean | undefined;
        type: "fallback";
    };
}> | z.ZodObject<{
    name: z.ZodString;
    type: z.ZodLiteral<"error">;
    hashableSignature: z.ZodString;
    hashedSignature: z.ZodString;
    fullSignature: z.ZodString;
    abiJSON: z.ZodObject<{
        type: z.ZodLiteral<"error">;
        name: z.ZodString;
        inputs: z.ZodArray<z.ZodObject<{
            name: z.ZodOptional<z.ZodString>;
            type: z.ZodString;
            components: z.ZodOptional<z.ZodArray<z.ZodAny, "many">>;
        }, "strip", z.ZodTypeAny, {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }, {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }>, "many">;
    }, "strip", z.ZodTypeAny, {
        type: "error";
        name: string;
        inputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }[];
    }, {
        type: "error";
        name: string;
        inputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }[];
    }>;
    default: z.ZodOptional<z.ZodBoolean>;
}, "strip", z.ZodTypeAny, {
    default?: boolean | undefined;
    type: "error";
    name: string;
    hashableSignature: string;
    hashedSignature: string;
    fullSignature: string;
    abiJSON: {
        type: "error";
        name: string;
        inputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }[];
    };
}, {
    default?: boolean | undefined;
    type: "error";
    name: string;
    hashableSignature: string;
    hashedSignature: string;
    fullSignature: string;
    abiJSON: {
        type: "error";
        name: string;
        inputs: {
            name?: string | undefined;
            components?: any[] | undefined;
            type: string;
        }[];
    };
}>>;
export declare type ABI_Row = z.infer<typeof ABI_RowZ>;
export declare type ABI_Constructor = z.infer<typeof ABI_ConstructorZ>;
export declare type ABI_Function = z.infer<typeof ABI_FunctionZ>;
export declare type ABI_Event = z.infer<typeof ABI_EventZ>;
export declare type ABI_Receive = z.infer<typeof ABI_ReceiveZ>;
export declare type ABI_Fallback = z.infer<typeof ABI_FallbackZ>;
export declare type ABI_Error = z.infer<typeof ABI_ErrorZ>;
export declare type ABI_ItemUnfiltered = z.infer<typeof ABI_ItemUnfilteredZ>;
export declare type ABI_Item = z.infer<typeof ABI_ItemZ>;
export declare type EventSigOptions = {
    [hashedSignature: string]: ABI_Event[];
};
export {};
