"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.functionSchema = exports.OptionalBigNumberZ = exports.BigNumberZ = exports.HashZ = exports.optionalAddressZ = exports.AddressZ = exports.boolean = exports.string = exports.nullableInt = exports.int = exports.number = exports.toLowercaseFn = exports.hashRegex = exports.addressRegex = void 0;
const ethers_1 = require("ethers");
const zod_1 = require("zod");
exports.addressRegex = new RegExp(/^0x[a-fA-F0-9]{40}$/);
exports.hashRegex = new RegExp(/^0x[a-fA-F0-9]*$/);
const toLowercaseFn = (x) => x.toLowerCase();
exports.toLowercaseFn = toLowercaseFn;
exports.number = zod_1.z.number();
exports.int = zod_1.z.number().int();
exports.nullableInt = exports.number.int().nullable();
exports.string = zod_1.z.string();
exports.boolean = zod_1.z.boolean();
exports.AddressZ = zod_1.z.string().regex(exports.addressRegex).transform(exports.toLowercaseFn);
exports.optionalAddressZ = exports.AddressZ.nullable();
exports.HashZ = exports.string.regex(exports.hashRegex).transform(exports.toLowercaseFn); // TODO is there a char count?
// export const BigNumberZ = string.transform((val) => BigNumber.from(val))
exports.BigNumberZ = zod_1.z
    .preprocess((val) => (typeof val == 'string' ? val : val.toString()), exports.string)
    .transform((val) => ethers_1.BigNumber.from(val));
exports.OptionalBigNumberZ = exports.BigNumberZ.optional();
exports.functionSchema = zod_1.z.function().args(exports.AddressZ).returns(exports.AddressZ);
//# sourceMappingURL=utils.js.map