import { DecodedTx } from '../interfaces/decoded';
import { Action, AssetType, Interpretation } from '../interfaces/interpreted';
export declare type ZenLedgerRow = {
    Timestamp: string;
    Type: ZenLedgerRowType | null;
    'In Amount': number | null;
    'In Currency': string | null;
    'Out Amount': number | null;
    'Out Currency': string | null;
    'Fee Amount': number;
    'Fee Currency': string;
    'Exchange(optional)': string | null;
    'US Based': 'Yes' | 'No';
    txHash: string;
    action: Action;
    'received type': AssetType | null;
    'received amount': number | null;
    'received symbol': string | null;
    'received type 2': AssetType | null;
    'received amount 2': number | null;
    'received symbol 2': string | null;
    'sent type': AssetType | null;
    'sent amount': number | null;
    'sent symbol': string | null;
    'sent type 2': AssetType | null;
    'sent amount 2': number | null;
    'sent symbol 2': string | null;
    explorerUrl: string;
    userInitiated: 'true' | 'false';
    method: string;
    contract: string;
    toAddress: string | null;
};
export declare enum ZenLedgerRowType {
    buy = "Buy",
    sell = "Sell",
    trade = "Trade",
    receive = "Receive",
    send = "Send",
    airdrop = "Airdrop",
    payment = "Payment",
    gift_sent = "Gift sent",
    fee = "Fee",
    staking_reward = "Staking reward",
    interest_received = "Interest received",
    misc_reward = "Misc reward",
    lost = "Lost",
    stolen = "Stolen",
    nft_mint = "Nft Mint",
    donation_501c3 = "Donation 501c3",
    unknown = "Unknown"
}
export declare type ZenLedgerData = {
    decodedTx: DecodedTx;
    interpretedData: Interpretation;
    taxData?: ZenLedgerRow;
};
