"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../utils");
const erc20_json_1 = __importDefault(require("../utils/ABIs/erc20.json"));
const erc721_json_1 = __importDefault(require("../utils/ABIs/erc721.json"));
const openZeppelin_json_1 = __importDefault(require("../utils/ABIs/openZeppelin.json"));
const mongoose_1 = require("../utils/mongoose");
function run() {
    return __awaiter(this, void 0, void 0, function* () {
        const db = new mongoose_1.MongooseDatabaseInterface('mongodb://localhost:27017/evm-translator');
        yield db.connect();
        const erc20rows = (0, utils_1.abiArrToAbiRows)((0, utils_1.filterABI)(erc20_json_1.default));
        const erc721rows = (0, utils_1.abiArrToAbiRows)((0, utils_1.filterABI)(erc721_json_1.default));
        const openZeppelinRows = (0, utils_1.abiArrToAbiRows)((0, utils_1.filterABI)(openZeppelin_json_1.default));
        const erc20rowsWithDefaults = erc20rows.map((row) => {
            row.default = true;
            return row;
        });
        const erc721rowsWithDefaults = erc721rows.map((row) => {
            row.default = true;
            return row;
        });
        const openZeppelinRowsWithDefaults = openZeppelinRows.map((row) => {
            row.default = true;
            return row;
        });
        yield db.addOrUpdateManyABI(erc20rowsWithDefaults);
        yield db.addOrUpdateManyABI(erc721rowsWithDefaults);
        yield db.addOrUpdateManyABI(openZeppelinRowsWithDefaults);
        console.log('done');
        db.closeConnection();
        process.exit(0);
    });
}
run();
//# sourceMappingURL=seed-db.js.map