"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NullDatabaseInterface = exports.DatabaseInterface = void 0;
class DatabaseInterface {
}
exports.DatabaseInterface = DatabaseInterface;
class NullDatabaseInterface extends DatabaseInterface {
    // skip for now
    getContractDataForContract(contractAddress) {
        return __awaiter(this, void 0, void 0, function* () {
            return Promise.resolve(null);
        });
    }
    // implemented
    getManyContractDataMap(contractAddresses) {
        return __awaiter(this, void 0, void 0, function* () {
            const obj = {};
            for (let i = 0; i < contractAddresses.length; i++) {
                obj[contractAddresses[i]] = null;
            }
            return Promise.resolve(obj);
        });
    }
    // skip for now
    addOrUpdateContractData(contractData) {
        return __awaiter(this, void 0, void 0, function* () {
            return Promise.resolve();
        });
    }
    // implemented
    addOrUpdateManyContractData(contractDataArr) {
        return __awaiter(this, void 0, void 0, function* () {
            return Promise.resolve();
        });
    }
    /** Contracts often don't have their full ABI shared, but we can infer it using a signature table when we see a contract using that ABI */
    AppendABIsToContractData(contractAddress, abi) {
        return __awaiter(this, void 0, void 0, function* () {
            return Promise.resolve();
        });
    }
    // skip for now
    addOrUpdateABI(abiArr) {
        return __awaiter(this, void 0, void 0, function* () {
            return Promise.resolve();
        });
    }
    // implemented
    addOrUpdateManyABI(abiArr) {
        return __awaiter(this, void 0, void 0, function* () {
            return Promise.resolve();
        });
    }
    /** Returns an array b/c there might be more than one full signature per hex signature. hex<-->hashable is 1:1*/
    // implemented
    getABIsForHexSignature(hexSignature) {
        return __awaiter(this, void 0, void 0, function* () {
            return Promise.resolve([]);
        });
    }
    getEventABIsForHexSignature(hexSignature) {
        return __awaiter(this, void 0, void 0, function* () {
            return Promise.resolve([]);
        });
    }
    getManyEventABIsForHexSignatures(hexSignatures) {
        return __awaiter(this, void 0, void 0, function* () {
            return Promise.resolve({});
        });
    }
    getFunctionABIsForHexSignature(hexSignature) {
        return __awaiter(this, void 0, void 0, function* () {
            return Promise.resolve([]);
        });
    }
    getFirstABIForHexSignature(hexSignature) {
        return __awaiter(this, void 0, void 0, function* () {
            return Promise.resolve(null);
        });
    }
    getABIRowsForHexSignature(hexSignature) {
        return __awaiter(this, void 0, void 0, function* () {
            return Promise.resolve(null);
        });
    }
    getFirstABIRowForHexSignature(hexSignature) {
        return __awaiter(this, void 0, void 0, function* () {
            return Promise.resolve(null);
        });
    }
    getEntityByAddress(address) {
        return __awaiter(this, void 0, void 0, function* () {
            return Promise.resolve(null);
        });
    }
    getDecodedTx(txHash) {
        return __awaiter(this, void 0, void 0, function* () {
            return Promise.resolve(null);
        });
    }
    getManyDecodedTxMap(txHashes) {
        return __awaiter(this, void 0, void 0, function* () {
            const obj = {};
            for (let i = 0; i < txHashes.length; i++) {
                obj[txHashes[i]] = null;
            }
            return Promise.resolve(obj);
        });
    }
    getManyNameDataMap(addresses) {
        return __awaiter(this, void 0, void 0, function* () {
            const obj = {};
            for (let i = 0; i < addresses.length; i++) {
                obj[addresses[i]] = null;
            }
            return Promise.resolve(obj);
        });
    }
    getManyEntityMap(addresses) {
        return __awaiter(this, void 0, void 0, function* () {
            const obj = {};
            for (let i = 0; i < addresses.length; i++) {
                obj[addresses[i]] = null;
            }
            return Promise.resolve(obj);
        });
    }
    addOrUpdateManyDecodedTx(decodedData) {
        return __awaiter(this, void 0, void 0, function* () {
            return Promise.resolve();
        });
    }
    deleteManyDecodedTxs(txHashes) {
        return __awaiter(this, void 0, void 0, function* () {
            return Promise.resolve(0);
        });
    }
    addOrUpdateInterpretedData(interpretedData) {
        return __awaiter(this, void 0, void 0, function* () {
            return Promise.resolve();
        });
    }
    addOrUpdateManyInterpretedData(interpretedDataArr) {
        return __awaiter(this, void 0, void 0, function* () {
            return Promise.resolve();
        });
    }
    getInterpretedData(txHash, userAddress) {
        return __awaiter(this, void 0, void 0, function* () {
            return Promise.resolve(null);
        });
    }
    getManyInterpretedData(txHashes, userAddress) {
        return __awaiter(this, void 0, void 0, function* () {
            return Promise.resolve(null);
        });
    }
    getAllInterpretationsForTxHash(txHash) {
        return __awaiter(this, void 0, void 0, function* () {
            return Promise.resolve(null);
        });
    }
    getAllInterpretationsForAddress(address) {
        return __awaiter(this, void 0, void 0, function* () {
            return Promise.resolve(null);
        });
    }
}
exports.NullDatabaseInterface = NullDatabaseInterface;
//# sourceMappingURL=DatabaseInterface.js.map