import { ABI_ItemUnfiltered } from '../../interfaces/abi';
import { Fetcher } from '../../utils';
export declare const enum EtherscanServiceLevel {
    free = 5,
    standard = 10,
    advanced = 20,
    professional = 30
}
export declare type SourceCodeObject = {
    SourceCode: string;
    ABI: string;
    ContractName: string;
    CompilerVersion: string;
    OptimizationUsed: string;
    Runs: string;
    ConstructorArguments: string;
    EVMVersion: string;
    Library: string;
    LicenseType: string;
    Proxy: string;
    Implementation: string;
    SwarmSource: string;
};
export default class Etherscan {
    baseUrl: string;
    apiKey: string;
    fetcher: Fetcher;
    constructor(apiKey: string, etherscanServiceLevel?: EtherscanServiceLevel);
    createUrl(params: Record<string, any>): string;
    static abiParams(contractAddress: string): Record<string, string>;
    static parseABIResponse(response: any, address?: string | null): ABI_ItemUnfiltered[];
    getABI(contractAddress: string): Promise<ABI_ItemUnfiltered[]>;
    getABIs(contractAddresses: string[]): Promise<Record<string, ABI_ItemUnfiltered[]>>;
    getSourceCode(contractAddress: string): Promise<SourceCodeObject>;
}
