"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const axios_1 = __importDefault(require("axios"));
const limiter_1 = require("limiter");
// 'second', 'minute', 'day', or a number of milliseconds
const limiter = new limiter_1.RateLimiter({ tokensPerInterval: 10, interval: 'second' });
function getMethodSignature(hexSignature) {
    return __awaiter(this, void 0, void 0, function* () {
        // if (this.#fnSigCache[hex_signature]) return this.#fnSigCache[hex_signature]
        const remaining = yield limiter.removeTokens(1);
        if (remaining < 1) {
            console.log('4byte rate limiter engaged. tokens remaining:', remaining);
        }
        try {
            const method = yield axios_1.default
                .get('https://www.4byte.directory/api/v1/signatures', { params: { hex_signature: hexSignature } })
                .then(({ data: { results } }) => { var _a, _b, _c; return (_c = (_b = (_a = results[results.length - 1]) === null || _a === void 0 ? void 0 : _a.text_signature) === null || _b === void 0 ? void 0 : _b.split('(')) === null || _c === void 0 ? void 0 : _c[0]; });
            return method;
        }
        catch (err) {
            console.log('err', err);
            return '';
        }
        // return method
    });
}
function getEventSignature(hexSignature) {
    return __awaiter(this, void 0, void 0, function* () {
        // if (this.#fnSigCache[hex_signature]) return this.#fnSigCache[hex_signature]
        const remaining = yield limiter.removeTokens(1);
        if (remaining < 1) {
            console.log('4byte rate limiter engaged. tokens remaining:', remaining);
        }
        try {
            const method = yield axios_1.default
                .get('https://www.4byte.directory/api/v1/event-signatures', { params: { hex_signature: hexSignature } })
                .then(({ data: { results } }) => results === null || results === void 0 ? void 0 : results.text_signature);
            return method;
        }
        catch (err) {
            console.log('err', err);
            return '';
        }
        // return method
    });
}
const fourByteDirectory = {
    getMethodSignature,
    getEventSignature,
};
exports.default = fourByteDirectory;
//# sourceMappingURL=FourByteDirectory.js.map