"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const providers_1 = require("@ethersproject/providers");
const safe_ethers_lib_1 = __importDefault(require("@gnosis.pm/safe-ethers-lib"));
const safe_service_client_1 = __importDefault(require("@gnosis.pm/safe-service-client"));
const ethers_1 = require("ethers");
function isGnosisSafeMaybe(address, provider) {
    return __awaiter(this, void 0, void 0, function* () {
        const jsonProvider = new providers_1.StaticJsonRpcProvider(provider.connection);
        const signer = jsonProvider.getSigner();
        const ethAdapter = new safe_ethers_lib_1.default({ ethers: ethers_1.ethers, signer });
        const txServiceUrl = 'https://safe-transaction.gnosis.io';
        const safeService = new safe_service_client_1.default({ txServiceUrl, ethAdapter });
        try {
            const safeInfo = yield safeService.getSafeInfo(address);
            return "Gnosis Safe" /* ContractType.GNOSIS */;
        }
        catch (e) {
            return "OTHER" /* ContractType.OTHER */;
        }
    });
}
exports.default = isGnosisSafeMaybe;
//# sourceMappingURL=isGnosisSafeMaybe.js.map