import winston from 'winston';
export declare const winstonLogger: winston.Logger;
export declare const timingLogger: winston.Logger;
export declare const logger: winston.Logger;
export declare const logTimer: (logData: LogData, message?: any) => void;
export declare const logDebug: (logData: LogData, message: any) => void;
export declare const logInfo: (logData: LogData, message: any) => void;
export declare const logWarning: (logData: LogData, message: any) => void;
export declare const logError: (logData: LogData, error: any, alert?: boolean) => void;
export declare const logSuccess: (logData: LogData, message?: string) => void;
export declare type LogData = {
    level?: 'emerg' | 'alert' | 'crit' | 'error' | 'warning' | 'notice' | 'info' | 'debug';
    tx_hash?: string;
    address?: string;
    message?: any;
    event_hash?: string;
    method_hash?: string;
    seconds_elapsed?: number;
    thrown_error?: any;
    extra?: any;
    function_name?: string;
    log_item?: any;
    abi_item?: any;
    method_id?: string;
    method_data?: string;
};
export declare type LogDataWithLevelAnd = LogData & {
    level: 'emerg' | 'alert' | 'crit' | 'error' | 'warning' | 'notice' | 'info' | 'debug';
    message: any;
};
