"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.logSuccess = exports.logError = exports.logWarning = exports.logInfo = exports.logDebug = exports.logTimer = exports.logger = exports.timingLogger = exports.winstonLogger = void 0;
const datadog_winston_1 = __importDefault(require("datadog-winston"));
const winston_1 = __importStar(require("winston"));
// const { combine, printf, colorize, errors } = format
const colors = {
    error: 'red',
    warning: 'yellow',
    info: 'green',
    http: 'magenta',
    debug: 'white',
};
winston_1.default.addColors(colors);
// const devFormat = printf((info) => `${info.level}: ${info.message}`)
const debugFormat = winston_1.format.prettyPrint();
// const prodFormat = printf((d) => {
//     const txHash = d.txHash ? `${d.txHash}` : 'unknown txHash'
//     const address = d.address ? ` | ${d.address}` : ' | unknown address'
//     const message = d.message ? ` | ${d.message}` : ''
//     const error = d.error ? ` | ${d.error}` : ''
//     return `${d.level}: ${txHash}${address}${message}${error}`
// })
// const timingFormat = printf((d) => {
//     let type = 'unknown type'
//     let val = null
//     if (d.eventHash) {
//         type = 'eventHash'
//         val = `${d.address} | ${d.eventHash}`
//     } else if (d.methodHash) {
//         type = 'methodHash'
//         val = `${d.address} | ${d.methodHash}`
//     } else if (d.txHash) {
//         type = 'txHash'
//         val = d.txHash
//     } else if (d.blockNumber) {
//         type = 'blockNumber'
//         val = d.blockNumber
//     } else if (d.address) {
//         type = 'address'
//         val = d.address
//     } else if (d.secondsElapsed) {
//         type = 'timer'
//         val = d.secondsElapsed
//     }
//     // const txHash = d.txHash ? `${d.txHash}` : 'unknown txHash'
//     // const address = d.address ? ` | ${d.address}` : ' | unknown address'
//     const message = d.message ? ` | ${d.message}` : ''
//     const error = d.error ? ` | ${d.error}` : ''
//     const extra = d.extra ? ` | ${d.extra}` : ''
//     return `${d.level}: ${type}: ${val} ${message}${error}${extra}`
// })
const service = process.env.VERCEL_ENV === 'production' ? 'metabot-logger' : 'metabot-dev-logger';
const prodTransports = process.env.DATADOG_API_KEY
    ? [
        new datadog_winston_1.default({
            apiKey: process.env.DATADOG_API_KEY,
            hostname: 'vercel',
            service,
            ddsource: 'nodejs',
            ddtags: `env:${process.env.VERCEL_ENV}, git_sha:${process.env.VERCEL_GIT_COMMIT_SHA}, git_ref:${process.env.VERCEL_GIT_COMMIT_REF}`,
        }),
    ]
    : [];
const localTransports = [new winston_1.default.transports.Console({ level: 'debug' })];
const timerTransports = [];
const isProdEnv = process.env.NODE_ENV === 'production';
if (!isProdEnv) {
    localTransports.push(new winston_1.default.transports.File({ level: 'warning', filename: 'logs/warnings.log' }));
    localTransports.push(new winston_1.default.transports.File({ level: 'error', filename: 'logs/errors.log' }));
    // localTransports.push(new winston.transports.File({ level: 'info', filename: 'logs/info.log' }))
    timerTransports.push(new winston_1.default.transports.File({ level: 'debug', filename: 'logs/timers.log' }));
}
exports.winstonLogger = winston_1.default.createLogger({
    levels: winston_1.default.config.syslog.levels,
    format: debugFormat,
    transports: isProdEnv ? prodTransports : localTransports,
});
exports.timingLogger = winston_1.default.createLogger({
    levels: winston_1.default.config.syslog.levels,
    format: debugFormat,
    transports: isProdEnv ? undefined : timerTransports,
});
// export const debugLogger = winston.createLogger({
//     levels: winston.config.syslog.levels,
//     format: devFormat,
//     transports: isProdEnv ? prodTransports : localTransports,
// })
// export const logger = isProdEnv ? winstonLogger : console
exports.logger = exports.winstonLogger;
const logTimer = (logData, message) => {
    const data = Object.assign(Object.assign({}, logData), { level: 'info', message });
    exports.timingLogger.log(data);
};
exports.logTimer = logTimer;
// export const debug = (message: any) => {
//     debugLogger.debug(message)
// }
const logDebug = (logData, message) => {
    const logDataCopy = Object.assign(Object.assign({}, logData), { level: 'debug', message });
    exports.logger.log(logDataCopy);
};
exports.logDebug = logDebug;
const logInfo = (logData, message) => {
    const logDataCopy = Object.assign(Object.assign({}, logData), { level: 'info', message });
    exports.logger.log(logDataCopy);
};
exports.logInfo = logInfo;
const logWarning = (logData, message) => {
    const logDataCopy = Object.assign(Object.assign({}, logData), { level: 'warning', message });
    exports.logger.log(logDataCopy);
};
exports.logWarning = logWarning;
// export const logError = (logData: LogData, message: any) => {
//     const logDataCopy = { ...logData, level: 'error', message }
//     logger.log(logDataCopy)
// }
const logError = (logData, error, alert = false) => {
    const logDataCopy = Object.assign(Object.assign({}, logData), { level: 'error', message: (error === null || error === void 0 ? void 0 : error.message) || 'error obj had no .message', alert });
    logDataCopy.thrown_error = error;
    exports.logger.log(logDataCopy);
};
exports.logError = logError;
const logSuccess = (logData, message = 'success') => {
    const logDataCopy = Object.assign(Object.assign({}, logData), { level: 'info', message });
    exports.logger.log(logDataCopy);
};
exports.logSuccess = logSuccess;
// const prodFormat = printf(
//     (d) =>
//         `${d.level}: token_id ${d.token_id} | ${d.function_name} | ${
//             d.third_party_name ? `${d.third_party_name} | ` : ''
//         }${d.attempt_number ? `attempt ${d.attempt_number} | ` : ''}${d.message}`,
// )
//# sourceMappingURL=logging.js.map