"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DecodedTxModel = void 0;
const mongoose_1 = require("mongoose");
const DecodedTxSchema = new mongoose_1.Schema({
    txHash: { type: String, required: true },
    txType: { type: String, required: true },
    contractType: { type: String, required: true },
    methodCall: {
        type: {
            name: String,
            arguments: { type: Object, required: true },
            decoded: Boolean,
        },
        required: true,
    },
    traceCalls: {
        type: [],
        required: true,
    },
    contractName: String,
    officialContractName: { type: String, required: false },
    fromENS: { type: String, required: false },
    toENS: { type: String, required: false },
    interactions: {
        type: [
            {
                contractName: String,
                contractSymbol: String,
                contractAddress: String,
                contractType: String,
                events: [],
            },
        ],
        required: true,
    },
    nativeValueSent: { type: String, required: true },
    chainSymbol: { type: String, required: true },
    txIndex: { type: Number, required: true },
    fromAddress: { type: String, required: true },
    toAddress: { type: String, required: false },
    reverted: { type: Boolean, required: true },
    timestamp: { type: Number, required: true },
    gasUsed: { type: String, required: true },
    effectiveGasPrice: { type: String, required: false },
}, { minimize: false }).index({ txHash: 1 }, { unique: true });
exports.DecodedTxModel = mongoose_1.models.decodedTx || (0, mongoose_1.model)('decodedTx', DecodedTxSchema);
//# sourceMappingURL=decodedTx.js.map