"use strict";
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _Timer_timers;
Object.defineProperty(exports, "__esModule", { value: true });
const logging_1 = require("./logging");
class Timer {
    constructor() {
        this.globalTimer = 0;
        _Timer_timers.set(this, {});
    }
    logDev(secondsElapsed, message) {
        if (process.env.NODE_ENV !== 'development')
            return;
        (0, logging_1.logTimer)({ seconds_elapsed: secondsElapsed }, message);
    }
    startGlobalTimer() {
        this.globalTimer = new Date().getTime();
    }
    globalElapsed() {
        return (new Date().getTime() - this.globalTimer) / 1000;
    }
    startTimer(key) {
        __classPrivateFieldGet(this, _Timer_timers, "f")[key] = new Date().getTime();
        // this.debug(`${this.globalTimer ? `${this.globalElapsed()}s:` : ''} started loading ${key}`)
    }
    stopTimer(key) {
        const elapsed = (new Date().getTime() - __classPrivateFieldGet(this, _Timer_timers, "f")[key]) / 1000;
        delete __classPrivateFieldGet(this, _Timer_timers, "f")[key];
        this.logDev(elapsed, key);
        // this.logDev(`${this.globalTimer ? `${this.globalElapsed()}s:` : ''} ${key} took ${elapsed}s`)
        return elapsed;
    }
    time(key, op) {
        this.startTimer(key);
        const result = op();
        this.stopTimer(key);
        return result;
    }
}
_Timer_timers = new WeakMap();
exports.default = new Timer();
//# sourceMappingURL=timer.js.map