"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const index_1 = __importStar(require("../index"));
const constants_1 = require("../utils/constants");
function getTranslator(address = null, networkId = 1) {
    return __awaiter(this, void 0, void 0, function* () {
        const chain = Object.values(index_1.chains).find((chain) => chain.id === networkId) || index_1.chains.ethereum;
        const translator = new index_1.default({
            chain,
            nodeUrl: constants_1.RPC_NODE_URL,
            alchemyProjectId: constants_1.ALCHEMY_PROJECT_ID !== null && constants_1.ALCHEMY_PROJECT_ID !== void 0 ? constants_1.ALCHEMY_PROJECT_ID : '',
            etherscanAPIKey: constants_1.ETHERSCAN_API_KEY !== null && constants_1.ETHERSCAN_API_KEY !== void 0 ? constants_1.ETHERSCAN_API_KEY : '',
            connectionString: constants_1.EVM_TRANSLATOR_CONNECTION_STRING,
            covalentAPIKey: constants_1.COVALENT_API_KEY,
            etherscanServiceLevel: 30,
            userAddress: address !== null && address !== void 0 ? address : undefined,
        });
        if (address)
            translator.updateUserAddress(address);
        yield translator.initializeMongoose();
        return translator;
    });
}
exports.default = getTranslator;
//# sourceMappingURL=translator.js.map